using System;
using System.Threading;
using Microsoft.SPOT;
using GHI.Pins;

using Microtoolskit.Hardware.MotorDrivers;


namespace PANDA_3_EasyStepperMot
{
    public class Program
    { // Description de la classe EasyStepperDriver : https://github.com/WebGE/EasyStepperDriver
        public static void Main()
        {
            // Programme de test d'un moteur pas  pas ITC-VNC-2
            // N=200 pas - U=12V - C=200g/cmavec une carte EasyStepperMotor 
            var time = 2000; UInt16 delay = 2; UInt32 nbpas = 200;
            var stepper = new EasyStepperDriver(FEZPandaIII.Gpio.D13, FEZPandaIII.Gpio.D12, FEZPandaIII.Gpio.D2, FEZPandaIII.Gpio.D10, FEZPandaIII.Gpio.D11, FEZPandaIII.Gpio.D3);

            while (true)
            {
                Debug.Print("Full Forward"); // 360 for ITC-VNC-1 motor
                Debug.Print("Pas= " + stepper.Steps + " Mode= " + stepper.StepMode + " Dir= " + stepper.StepDirection + " time= " + stepper.StepDelay + "ms" + "\n");
                stepper.Turn(nbpas, EasyStepperDriver.Direction.Forward, delay, EasyStepperDriver.Mode.Full);
                Thread.Sleep(time);

                Debug.Print("Half Backward"); // 180 for ITC-VNC-1 motor              
                Debug.Print("Pas= " + stepper.Steps + " Mode= " + stepper.StepMode + " Dir= " + stepper.StepDirection + " time= " + stepper.StepDelay + "ms" + "\n");
                stepper.Turn(nbpas, EasyStepperDriver.Direction.Backward, delay, EasyStepperDriver.Mode.Half);
                Thread.Sleep(time);

                Debug.Print("Quater Forward"); // 90 for ITC-VNC-1 motor               
                Debug.Print("Pas= " + stepper.Steps + " Mode= " + stepper.StepMode + " Dir= " + stepper.StepDirection + " time= " + stepper.StepDelay + "ms" + "\n");
                stepper.Turn(nbpas, EasyStepperDriver.Direction.Forward, delay, EasyStepperDriver.Mode.Quarter);
                Thread.Sleep(time);

                Debug.Print("OneEighth Backward"); // 45 for ITC-VNC-1 motor              
                Debug.Print("Pas= " + stepper.Steps + " Mode= " + stepper.StepMode + " Dir= " + stepper.StepDirection + " time= " + stepper.StepDelay + "ms" + "\n");
                stepper.Turn(nbpas, EasyStepperDriver.Direction.Backward, 1, EasyStepperDriver.Mode.OneEighth);
                Thread.Sleep(time);

                Debug.Print("Full Forward"); // 45 for ITC-VNC-1 motor
                Debug.Print("Pas= " + stepper.Steps + " Mode= " + stepper.StepMode + " Dir= " + stepper.StepDirection + " time= " + stepper.StepDelay + "ms" + "\n");
                stepper.StepMode = EasyStepperDriver.Mode.Full; stepper.StepDirection = EasyStepperDriver.Direction.Backward;
                stepper.Turn(25);
                Thread.Sleep(2 * time);
            }
        }
    }
}
